/**
 * @author R�mi Heredero
 * @version 1.0.0
 * @date August 2023
 * @file eeprom_interface.h
 */
#ifndef EEPROM_INTERFACE_H
#define	EEPROM_INTERFACE_H

#include <stdint.h>         // usage of standard types
#include <stdbool.h>        // usage of boolean types
#include "../mcc_generated_files/mcc.h"

void MEM_init();
void MEM_reset();
void MEM_write_1_byte(uint8_t address, uint8_t data);
void MEM_write_4_byte(uint8_t address, uint32_t data);
uint8_t MEM_read_1_byte(uint8_t address);
uint32_t MEM_read_4_byte(uint8_t address);

#endif	/* EEPROM_INTERFACE_H */

